
org	0000h
	jmp	pi_start
org	0003h
	reti
;	jmp	po_int0
org	000Bh
	reti
;	jmp	po_T0
org	0013h
	reti
;	jmp	po_int1
org	001Bh
	reti
;	jmp	po_T1
org	0023h
;	clr	TI
;	clr	RI
	reti
;	jmp	po_com


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;; definicja zmiennych ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
key	equ	20h


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

pi_start:
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;; konfiguracja portu transmisji szeregowej ;;;;;;;;;;;
	mov	SCON,#10010000b
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;; przypisanie wartoci pocztkowych zmiennym ;;;;;;;;;
	mov	key,#0ffh	


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;; testowanie pamici RAM 64kB ;;;;;;;;;;;;;;;;;;;;;;;;
pam1:
	mov	dptr,#0000h
pam:
	mov	a,#0
	movx	@dptr,a
	movx	a,@dptr
	cjne	a,#0,pam1
	mov	a,#255
	movx	@dptr,a
	movx	a,@dptr
	cjne	a,#255,pam1
	mov	a,dph
	jb	acc.0,pam2
	mov	a,#0
	jmp	pam3
pam2:
	mov	a,#084h
pam3:
	movx	@dptr,a
	inc	dptr

	mov	a,#0
	movx	@dptr,a
	movx	a,@dptr
	cjne	a,#0,pam1
	mov	a,#255
	movx	@dptr,a
	movx	a,@dptr
	cjne	a,#255,pam1
	mov	a,dph
	jb	acc.0,pam4
	mov	a,#0
	jmp	pam5
pam4:
	mov	a,#021h
pam5:
	movx	@dptr,a
	inc	dptr

	mov	a,dpl
	jnz	pam
	mov	a,dph
	jnz	pam
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

	clr	T0				; zawiecenie diodki LED gdy pami RAM sprawna

pi_start_program_aplikacji:

oczekujnank:				; odczyt stanu klawiatury
	mov	a,P1
	mov	key,a
	cjne	a,#0ffh,kn
	jmp	oczekujnank
kn:
	setb	T0				; zgaszenie diodki LED na czas obsugi klawiatury,
						; wygnerowania i wysania obrazu

	cjne	a,#11111110b,knp1
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;; procedura obsugi przycisku P1 (P1.0) ;;;;;;;;;;;;;

	call	zerekr

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
	call	wyslijobraz			; wysanie obrazu
	jmp	kobs
knp1:
	cjne	a,#11111101b,knp2
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;; procedura obsugi przycisku P2 (P1.1) ;;;;;;;;;;;;;

	mov	b,#0ffh
	call	tloekr

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;	
	call	wyslijobraz			; wysanie obrazu
	jmp	kobs
knp2:
	cjne	a,#11111011b,knp3
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;; procedura obsugi przycisku P3 (P1.2) ;;;;;;;;;;;;;



;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
	call	wyslijobraz			; wysanie obrazu
	jmp	kobs
knp3:
	cjne	a,#11110111b,knp4
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;; procedura obsugi przycisku P4 (P1.3) ;;;;;;;;;;;;;



;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
	call	wyslijobraz			; wysanie obrazu
	jmp	kobs
knp4:
	cjne	a,#11101111b,knp5
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;; procedura obsugi przycisku P5 (P1.4) ;;;;;;;;;;;;;



;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
	call	wyslijobraz			; wysanie obrazu
	jmp	kobs
knp5:
	cjne	a,#11011111b,knp6
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;; procedura obsugi przycisku P6 (P1.5) ;;;;;;;;;;;;;



;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
	call	wyslijobraz			; wysanie obrazu
	jmp	kobs
knp6:
	cjne	a,#10111111b,knp7
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;; procedura obsugi przycisku P7 (P1.6) ;;;;;;;;;;;;;



;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
	call	wyslijobraz			; wysanie obrazu
	jmp	kobs
knp7:
	cjne	a,#01111111b,knp8
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;; procedura obsugi przycisku P8 (P1.7) ;;;;;;;;;;;;;



;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
	call	wyslijobraz			; wysanie obrazu
	jmp	kobs
knp8:
kobs:
	clr	T0				; zawiecenie diody LED po wysaniu obrazu

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;; procedura oczekiwania na puszczenie przycisku ;;;;;
oczekujnapk:
	mov	a,P1
	mov	key,a
	cjne	a,#0ffh,oczekujnapk

	mov	r1,#40
	mov	r0,#00
oczekujnapk1:
	djnz	r0,oczekujnapk1
	djnz	r1,oczekujnapk1

	mov	a,P1
	mov	key,a
	cjne	a,#0ffh,oczekujnapk
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

	jmp	oczekujnank			; powrt na pcztek programu obsugi

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;; procedura wysyania obrazu ;;;;;;;;;;;;;;;;;;;;;;;;

wyslijobraz:

;;;;;;;;;;;;;;;;;;;;;;;;;;; procedura synchronizacji transmisji czem szeregowym
;	clr	RI
;cznbs_1:
;	jnb	RI,cznbs_1
;	mov	a,SBUF
;	clr	RI
;	cjne	a,#82,cznbs_1
;;;;;;;;;;;;;;;;;;;;;;;;;;;

;;;;;;;;;;;;;;;;;;;;;;;;;;; procedura synchronizacji lini INT0 transmisji czem szeregowym
;cznbs_1:
;	jb	INT0,cznbs_1
;;;;;;;;;;;;;;;;;;;;;;;;;;;

;;;;;;;;;;;;;;;;;;;;;;;;;;; procedura synchronizacji liniami INT0 i INT1 transmisji czem szeregowym
cznbs_1:
	mov	c,INT0
	anl	c,INT1
	jc	cznbs_1
;;;;;;;;;;;;;;;;;;;;;;;;;;;

;;;;;;;;;;;;;;;;;;;;;;;;;;; procedura wysyania pierwszego bloku bufora obrazu
	clr	TI
	mov	SBUF,#0
cznbs_1a:
	jnb	TI,cznbs_1a
	clr	TI
;;;;
	mov	dptr,#0000h
pwdps1_1:
	mov	r0,#20
pwdps_1:
	movx	a,@dptr
	mov	SBUF,a
	inc	dpl
cnwb_1:
	jnb	TI,cnwb_1
	clr	TI
	djnz	r0,pwdps_1
	mov	dpl,#0
	inc	dph
	mov	a,dph
	cjne	a,#10,pwdps1_1
;;;;;;;;;;;;;;;;;;;;;;;;;;;

;;;;;;;;;;;;;;;;;;;;;;;;;;; procedura synchronizacji transmisji czem szeregowym
;	clr	RI
;cznbs_2:
;	jnb	RI,cznbs_2
;	mov	a,SBUF
;	clr	RI
;	cjne	a,#82,cznbs_2
;;;;;;;;;;;;;;;;;;;;;;;;;;;

;;;;;;;;;;;;;;;;;;;;;;;;;;; procedura synchronizacji lini INT0 transmisji czem szeregowym
;cznbs_2:
;	jb	INT0,cznbs_2
;;;;;;;;;;;;;;;;;;;;;;;;;;;

;;;;;;;;;;;;;;;;;;;;;;;;;;; procedura synchronizacji liniami INT0 i INT1 transmisji czem szeregowym
cznbs_2:
	mov	c,INT0
	anl	c,INT1
	jc	cznbs_2
;;;;;;;;;;;;;;;;;;;;;;;;;;;

;;;;;;;;;;;;;;;;;;;;;;;;;;; procedura wysyania drugiego bloku bufora obrazu
	mov	SBUF,#1
cznbs_2a:
	jnb	TI,cznbs_2a
	clr	TI
;;;;
	mov	dptr,#0a00h
pwdps1_2:
	mov	r0,#20
pwdps_2:
	movx	a,@dptr
	mov	SBUF,a
	inc	dpl
cnwb_2:
	jnb	TI,cnwb_2
	clr	TI
	djnz	r0,pwdps_2
	mov	dpl,#0
	inc	dph
	mov	a,dph
	cjne	a,#20,pwdps1_2
;;;;;;;;;;;;;;;;;;;;;;;;;;;

;;;;;;;;;;;;;;;;;;;;;;;;;;; procedura synchronizacji transmisji czem szeregowym
;	clr	RI
;cznbs_3:
;	jnb	RI,cznbs_3
;	mov	a,SBUF
;	clr	RI
;	cjne	a,#82,cznbs_3
;;;;;;;;;;;;;;;;;;;;;;;;;;;

;;;;;;;;;;;;;;;;;;;;;;;;;;; procedura synchronizacji lini INT0 transmisji czem szeregowym
;cznbs_3:
;	jb	INT0,cznbs_3
;;;;;;;;;;;;;;;;;;;;;;;;;;;

;;;;;;;;;;;;;;;;;;;;;;;;;;; procedura synchronizacji liniami INT0 i INT1 transmisji czem szeregowym
cznbs_3:
	mov	c,INT0
	anl	c,INT1
	jc	cznbs_3
;;;;;;;;;;;;;;;;;;;;;;;;;;;

;;;;;;;;;;;;;;;;;;;;;;;;;;; procedura wysyania trzeciego bloku bufora obrazu
	mov	SBUF,#2
cznbs_3a:
	jnb	TI,cznbs_3a
	clr	TI
;;;;
	mov	dptr,#1400h
pwdps1_3:
	mov	r0,#20
pwdps_3:
	movx	a,@dptr
	mov	SBUF,a
	inc	dpl
cnwb_3:
	jnb	TI,cnwb_3
	clr	TI
	djnz	r0,pwdps_3
	mov	dpl,#0
	inc	dph
	mov	a,dph
	cjne	a,#30,pwdps1_3
;;;;;;;;;;;;;;;;;;;;;;;;;;;

;;;;;;;;;;;;;;;;;;;;;;;;;;; procedura synchronizacji transmisji czem szeregowym
;	clr	RI
;cznbs_4:
;	jnb	RI,cznbs_4
;	mov	a,SBUF
;	clr	RI
;	cjne	a,#82,cznbs_4
;;;;;;;;;;;;;;;;;;;;;;;;;;;

;;;;;;;;;;;;;;;;;;;;;;;;;;; procedura synchronizacji lini INT0 transmisji czem szeregowym
;cznbs_4:
;	jb	INT0,cznbs_4
;;;;;;;;;;;;;;;;;;;;;;;;;;;

;;;;;;;;;;;;;;;;;;;;;;;;;;; procedura synchronizacji liniami INT0 i INT1 transmisji czem szeregowym
cznbs_4:
	mov	c,INT0
	anl	c,INT1
	jc	cznbs_4
;;;;;;;;;;;;;;;;;;;;;;;;;;;

;;;;;;;;;;;;;;;;;;;;;;;;;;; procedura wysyania czwartego bloku bufora obrazu
	mov	SBUF,#3
cznbs_4a:
	jnb	TI,cznbs_4a
	clr	TI
;;;;
	mov	dptr,#1e00h
pwdps1_4:
	mov	r0,#20
pwdps_4:
	movx	a,@dptr
	mov	SBUF,a
	inc	dpl
cnwb_4:
	jnb	TI,cnwb_4
	clr	TI
	djnz	r0,pwdps_4
	mov	dpl,#0
	inc	dph
	mov	a,dph
	cjne	a,#40,pwdps1_4
	ret
;;;;;;;;;;;;;;;;;;;;;;;;;;;

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;; procedura zerowania bufora obrazu ;;;;;;;;;;;;;;;;;

zerekr:
	mov	dptr,#0000h
zerekr1:
	mov	a,#0
	movx	@dptr,a
	inc	dpl
	mov	a,dpl
	cjne	a,#20,zerekr1
	mov	dpl,#0
	inc	dph
	mov	a,dph
	cjne	a,#40,zerekr1
	ret

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;; procedura zapeniania ta w buforze obrazu ;;;;;;;;

tloekr:				; w rejestrze b to ekranu
	mov	dptr,#0000h
tloekr1:
;	mov	a,#88h
	mov	a,b
	movx	@dptr,a
	inc	dpl
	mov	a,dpl
	cjne	a,#20,tloekr1
	mov	dpl,#0
	inc	dph
	mov	a,dph
	cjne	a,#40,tloekr1
	ret

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;


tab:	db	'Generator Aplikacji,test grafiki.'
	db	'(c)2008 A.B. '

	END